blob: 21bae758dad9ba77d36429348f2ea00e8cc15ed1 [file] [log] [blame]
Martin Roth4769cc32016-06-02 16:42:29 -06001##
2## This file is part of the coreboot project.
3##
4## Copyright (C) 2017 Google Inc.
5##
6## This program is free software; you can redistribute it and/or modify
7## it under the terms of the GNU General Public License as published by
8## the Free Software Foundation; version 2 of the License.
9##
10## This program is distributed in the hope that it will be useful,
11## but WITHOUT ANY WARRANTY; without even the implied warranty of
12## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13## GNU General Public License for more details.
14##
15
16# force the shell to bash - the edksetup.sh script doesn't work with dash
17export SHELL := env bash
18
Martin Roth4769cc32016-06-02 16:42:29 -060019project_name=Tianocore
20project_dir=$(CURDIR)/tianocore
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060021project_git_repo=https://github.com/mrchromebox/edk2
22project_git_branch=coreboot_fb
23upstream_git_repo=https://github.com/tianocore/edk2
24
Lijian Zhao16562cb2019-07-20 13:06:03 +080025ifeq ($(CONFIG_TIANOCORE_UEFIPAYLOAD),y)
26bootloader=UefiPayloadPkg
Matt DeVillierb4a0ec52020-04-22 02:03:30 -050027logo_pkg=MdeModulePkg
Benjamin Doron3db439e2020-02-25 03:43:02 +000028build_flavor=-D BOOTLOADER=COREBOOT -D PCIE_BASE=$(CONFIG_MMCONF_BASE_ADDRESS) -DPS2_KEYBOARD_ENABLE
Lijian Zhao16562cb2019-07-20 13:06:03 +080029TAG=upstream/master
30else
31bootloader=CorebootPayloadPkg
Matt DeVillierb4a0ec52020-04-22 02:03:30 -050032logo_pkg=CorebootPayloadPkg
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060033# STABLE revision is MrChromebox's coreboot framebuffer (coreboot_fb) branch
Lijian Zhao16562cb2019-07-20 13:06:03 +080034TAG=origin/$(project_git_branch)
35endif
36
37ifneq ($(CONFIG_TIANOCORE_REVISION_ID),)
38TAG=$(CONFIG_TIANOCORE_REVISION_ID)
39endif
Martin Roth4769cc32016-06-02 16:42:29 -060040
41export EDK_TOOLS_PATH=$(project_dir)/BaseTools
42
43ifeq ($(CONFIG_TIANOCORE_DEBUG),y)
44BUILD_TYPE=DEBUG
45else
46BUILD_TYPE=RELEASE
47endif
48
Lijian Zhaocf9ea552018-09-07 17:58:08 -070049ifneq ($(CONFIG_TIANOCORE_USE_8254_TIMER), y)
50TIMER=-DUSE_HPET_TIMER
51endif
52
Martin Roth4769cc32016-06-02 16:42:29 -060053ifeq ($(CONFIG_TIANOCORE_TARGET_IA32), y)
Angel Pons6d295ac2020-02-25 21:35:45 +010054 BUILD_STR=-q -a IA32 -t COREBOOT -p $(bootloader)/$(bootloader)Ia32.dsc -b $(BUILD_TYPE) $(TIMER) $(build_flavor)
Martin Roth4769cc32016-06-02 16:42:29 -060055else
Angel Pons6d295ac2020-02-25 21:35:45 +010056 BUILD_STR=-q -a IA32 -a X64 -t COREBOOT -p $(bootloader)/$(bootloader)Ia32X64.dsc -b $(BUILD_TYPE) $(TIMER) $(build_flavor)
Martin Roth4769cc32016-06-02 16:42:29 -060057endif
58
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060059all: clean build
Martin Roth4769cc32016-06-02 16:42:29 -060060
61$(project_dir):
62 echo " Cloning $(project_name) from Git"
Matt DeVillieree69f732019-03-01 13:10:26 -060063 git clone --branch $(project_git_branch) $(project_git_repo) $(project_dir); \
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060064 cd $(project_dir); \
65 git remote add upstream $(upstream_git_repo)
Martin Roth4769cc32016-06-02 16:42:29 -060066
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060067update: $(project_dir)
68 cd $(project_dir); \
69 echo " Fetching new commits from the $(project_name) repo"; \
70 git fetch --multiple origin upstream 2>/dev/null; \
Lijian Zhao16562cb2019-07-20 13:06:03 +080071 if ! git rev-parse --verify -q $(TAG) >/dev/null; then \
72 echo " $(TAG) is not a valid git reference"; \
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060073 exit 1; \
Martin Roth4769cc32016-06-02 16:42:29 -060074 fi; \
Matt DeVillierae48b422020-04-21 23:54:42 -050075 if git status --ignore-submodules=dirty | grep -qv clean; then \
Lijian Zhao16562cb2019-07-20 13:06:03 +080076 echo " Checking out $(project_name) revision $(TAG)"; \
77 git checkout --detach $(TAG); \
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060078 else \
79 echo " Working directory not clean; will not overwrite"; \
Matt DeVillierae48b422020-04-21 23:54:42 -050080 fi; \
81 git submodule update --init --recursive
Martin Roth4769cc32016-06-02 16:42:29 -060082
83checktools:
84 echo "Checking uuid-dev..."
85 echo "#include <uuid/uuid.h>" > libtest.c
86 echo "int main(int argc, char **argv) { (void) argc; (void) argv; return 0; }" >> libtest.c
87 $(HOSTCC) $(HOSTCCFLAGS) libtest.c -o libtest >/dev/null 2>&1 && echo " found uuid-dev." || \
Patrick Rudolphe66b10f2018-06-16 11:14:16 +020088 ( echo " Not found."; echo "ERROR: please_install uuid-dev (libuuid-devel)"; exit 1 )
Martin Roth4769cc32016-06-02 16:42:29 -060089 rm -rf libtest.c libtest
90 echo "Checking nasm..."
91 type nasm > /dev/null 2>&1 && echo " found nasm." || \
92 ( echo " Not found."; echo "Error: Please install nasm."; exit 1 )
93
Matt DeVillier38b6ccf2019-02-20 23:46:15 -060094build: update checktools
Martin Roth4769cc32016-06-02 16:42:29 -060095 unset CC; $(MAKE) -C $(project_dir)/BaseTools
Lijian Zhao16562cb2019-07-20 13:06:03 +080096 echo " build $(project_name) $(TAG)"
Matt DeVillier98a47ac2020-04-29 15:29:27 -050097 if [ -n "$(CONFIG_TIANOCORE_BOOTSPLASH_FILE)" ]; then \
Matt DeVillierff793412019-02-21 22:41:59 -060098 echo " Copying custom bootsplash image"; \
99 case "$(CONFIG_TIANOCORE_BOOTSPLASH_FILE)" in \
100 /*) cp $(CONFIG_TIANOCORE_BOOTSPLASH_FILE) \
Matt DeVillierb4a0ec52020-04-22 02:03:30 -0500101 $(project_dir)/$(logo_pkg)/Logo/Logo.bmp;; \
Matt DeVillierff793412019-02-21 22:41:59 -0600102 *) cp $(top)/$(CONFIG_TIANOCORE_BOOTSPLASH_FILE) \
Matt DeVillierb4a0ec52020-04-22 02:03:30 -0500103 $(project_dir)/$(logo_pkg)/Logo/Logo.bmp;; \
Matt DeVillierff793412019-02-21 22:41:59 -0600104 esac \
105 fi; \
Martin Roth4769cc32016-06-02 16:42:29 -0600106 cd $(project_dir); \
107 export EDK_TOOLS_PATH=$(project_dir)/BaseTools; \
108 export WORKSPACE=$(project_dir); \
109 . ./edksetup.sh BaseTools; \
110 grep -q "COREBOOT" $(project_dir)/Conf/tools_def.txt; \
111 if [ $$? -ne 0 ]; then \
112 cat ../tools_def.txt >> $(project_dir)/Conf/tools_def.txt; \
113 fi; \
114 build $(BUILD_STR); \
Lijian Zhao16562cb2019-07-20 13:06:03 +0800115 mv $(project_dir)/Build/$(bootloader)*/*/FV/UEFIPAYLOAD.fd $(project_dir)/Build/UEFIPAYLOAD.fd; \
Matt DeVillierb4a0ec52020-04-22 02:03:30 -0500116 git checkout $(logo_pkg)/Logo/Logo.bmp > /dev/null 2>&1 || true
Martin Roth4769cc32016-06-02 16:42:29 -0600117
118clean:
119 test -d $(project_dir) && (cd $(project_dir); rm -rf Build; rm -f Conf/tools_def.txt) || exit 0
120
121distclean:
122 rm -rf $(project_dir)
123
Matt DeVillier38b6ccf2019-02-20 23:46:15 -0600124.PHONY: all update checktools config build clean distclean